<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { ref, watch } from 'vue'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { useRouter } from 'vue-router'
    import { UserApi } from '@/api/user/UserApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import SUserForm from '../../components/users/SUserForm.vue'
    import { User } from '@/api/user/User'
    import { useConfigurationStore } from '../../stores/ConfigurationStore'
    import { useServiceOffers } from '@/serviceOffer/components/composables/serviceOffer/serviceOffers'
    import { userMapper } from '@/api/user/UserMapper'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const user = ref<User>(
        new User({
            email: '',
            reachableRoles: [],
            roles: [],
        })
    )

    const router = useRouter()
    const { getParentRoute } = useBreadcrumb()

    const msal = useMsal()
    const userStore = useUserStore(msal)

    const configurationStore = useConfigurationStore()
    const serviceOfferStore = useServiceOffers()

    const userApi = new UserApi(msal)
    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            serviceOfferStore.loadServiceOffers(msal)
        },
        { immediate: true }
    )
    async function createUser() {
        try {
            const createdUserDto = userMapper.toCreateDto(user.value)
            const createdUser = await userApi.create(createdUserDto)

            emitSnackBar(`Utilisateur "${createdUser.email}" créé`, 'primary')
            router.push(getParentRoute())
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
            router.push(getParentRoute())
        }
    }
</script>

<template>
    <s-contextual-navbar
        page-title="Ajouter un utilisateur"
    ></s-contextual-navbar>
    <v-main>
        <s-content-container>
            <s-user-form
                v-model="user"
                :configuration-store="configurationStore"
                :service-offer-store="serviceOfferStore"
                :is-processing="userApi.isProcessing.value"
                @submit.prevent="createUser()"
            >
            </s-user-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
